% WF_paper_fig2.m

% Alistair Boettiger                                   Date Begun: 12/03/09
% Getz Lab                                          Last Modified: 12/03/09 

% 
% Whiskers extend to the furthest data point within 1.5*(3rd-1st quartile)
% Standard Matlab algorithm 

clear all;  load compsig_data2; 
 


bar1 = Err_data(1:13); bar2 = cell2mat(bar1');

C1 = [[0,0,0]
      [.2,.2,.2]
      [.5,.5,.5]
      [.7,.7,.7]
                ];

w = 2; % whisker length = furthest point w*(3rd-1st quartile)
dpts = length(ErrM);

colordef white; figure(1); set(gcf,'color','w'); 
xlabels = {'All factors','Past mov.','CoM mov.','NDVI','Static','Human','Water'};
 C = [1,2,2,3,4,4,4];

%  figure(1); clf;  boxplot(ErrM(:,1:7),'plotstyle','compact','labels',xlabels,'colorgroup',C,'colors',C1,'labelorientation','inline');
  figure(1); clf; boxplot(ErrM(:,1:7),'plotstyle','compact','labels',xlabels,...
      'colors',[.5,.5,.5],'labelorientation','inline','whisker',w);
ylabel('normalized MSE','FontSize',12); set(gca,'FontSize',12); ylim([0,1]);


 figure(3); clf; boxplot(ErrM(:,1:7),'labels',xlabels,'colors',[.5,.5,.5],...
     'labelorientation','inline','whisker',3);
ylabel('normalized MSE','FontSize',12); set(gca,'FontSize',12); ylim([0,1]);


load null_preds;
fig2 = [ErrM(:,[1,2,4,5]),m_err];
   xlabels2 = {'All factors','Past mov.','NDVI','Static Feat.','Null Model'};
   figure(2); clf; boxplot(fig2,'colors',[.3,.3,.3],'labels',xlabels2,...
       'plotstyle','compact','labelorientation','inline','whisker',w);
    ylim([0,.5]); ylabel('Normalized MSE')
    ylabel('normalized MSE','FontSize',12); set(gca,'FontSize',12);


xlabels2 = {'All factors','Past mov.','NDVI','Static Feat.'};
figure(2); clf; boxplot(fig2(:,1:4),'colors',[.3,.3,.3],...
       'labels',xlabels2,'plotstyle','compact','labelorientation','inline','whisker',w);
    ylim([0,.6]); ylabel('Normalized MSE')
    ylabel('normalized MSE','FontSize',12); set(gca,'FontSize',12);

Q1 = zeros(1,8); Q3 = zeros(1,8);
for i=1:8,
    vals = sort(ErrM(:,i));
    qpts = round(dpts/4);
    ind1 = find(vals>0,qpts,'first');
    ind3 = find(vals>0,qpts,'last');
    Q1(i) = vals(ind1(qpts));
    Q3(i) = vals(ind3(1));
end

    
[p,h,z] = ranksum(ErrM(:,2),ErrM(:,3))

% for k=1:13
%     Anna = bar1{k};
% %     figure(3); clf; bar(Anna(:,[1,2,4,5])) ;  ylim([0,5]);
% %     legend('all','mov','ndvi','static');
% 
%     iAnna = 1./Anna; 
%     figure(3); clf; bar(iAnna(:,[2,4,5]),'stack') ; 
%     legend('mov','ndvi','static');  colormap(C1);
%     set(gcf,'color','w'); 
%     set(gca,'FontSize',18);  xlim([0,55]);
% 
%     iAnna2 = iAnna(:,[2,4,5]);
%     [T,v] = size(Anna);
% 
%     for i=1:T; 
%     iAnna2(i,:) = iAnna2(i,:)/sum(iAnna2(i,:));
%     end
% 
%     figure(4); clf; bar(iAnna2,'stack') ; 
%     legend('mov','ndvi','static','Location','EastOutside');  colormap(C1);
%     set(gcf,'color','w'); set(gca,'FontSize',18); ylim([0,1]); xlim([0,55]);
% 
%     pause(3);
% end
