%                       WF_paper_fig3.m
%
%  Alistair Boettiger                                  Date Begun: 12/03/09
%  Getz Lab                                         Last Modified: 01/06/10

%  Load data and build figures for Fig3 and Fig 3S 


% Each row in ErrE is all the data of the elephant in that row predicted
% using the filter from the elephant specified by each of the columns.  

clear all; %close all; 
colordef white; 

load CrossETdata;
load null_preds;

null_err  = [m_err,m_err1,m_err2,m_err3,m_err4,m_err5];
m_err = median(null_err,2); 

[K,K,Fs] = size(ErrE);

ErrEb = ErrE;
ErrEn = ErrE;
newdat = zeros(K^2,Fs);

Di = logical(diag(ones(1,K)));

for j=1:Fs
    Errc = ErrE(:,:,j); % matrix is equal to orig data structure

     sm = mean(mean(Sdepth(:,:,j)));  
     if Sdepth(:,:,j)<1000
        Errc(Sdepth(:,:,j)<.25*sm) = NaN; % .25  Resrtict to require 25% of mean sampling depth 
     end
    ErrEn(:,:,j) = Errc; % this is stored as ErrEn structure (used for self E comparison)  
       nn(:,j) = reshape(Errc,K^2,1); 
    
     Errc(Di) = NaN*ones(1,K); % also remove diagnol 
    ErrEb(:,:,j) = Errc;  % This is stored as ErrEb,(for crossE comparison)
    
    newdat(:,j) = reshape(Errc,K^2,1); % stack 13 by 13 instead of repeated medians.
 
end


   
   bar2 = zeros(K,Fs); 
   for j=1:Fs
       bar2(:,j) = diag(ErrEn(:,:,j));
   end
     bar2 = [bar2,m_err];
     xlabels = {'no constraint',' ','same time',' ','same season',' ','nearby',' ','all constraints',' ','null model'};


bar1 = nanmedian(ErrEb); K =13;
bar1 = reshape(bar1,K,Fs); 

bar1_labels = {'no const','same time','same season','position','time,season'...
    'time,position','season,position','time,season,position','>t','>t,season,pos'};
alllabels = {'no const','same time','same season','position','time,season'...
    'time,position','season,position','time,season,position','>t','>t,season,pos'...
    'self no const','self same time','self same season','self position','self time,season'...
    'self time,position','self season,position','self time,season,position',...
    'self >t','self >t,season,pos','null model'};

colormap('hsv'); 

C1 = [ 
    .4*[1,1,1]
    .7*[1,1,1]
    .1*[1,1,1]
    ];

C = [1,2,1,2,1,2,1,2,1,2,3];

fig3 = [bar1(:,1),bar2(:,1),bar1(:,2),bar2(:,2),bar1(:,3),bar2(:,3),...
    bar1(:,4),bar2(:,4),bar1(:,8),bar2(:,8),m_err];
figure(3); clf; boxplot(fig3,'plotstyle','compact','labels',xlabels,'colorgroup',C,'colors',C1);
 ylim([0,10]); ylabel('Normalized MSE'); set(gcf,'color','w');
set(gca,'Xtick',[2.5, 4.5, 6.5, 8.5, 10.5]);

% alllabels = {'no constraint','same time','same season ','nearby',...
%     'time','time, pos','season, pos','all const', 'different time (>t)','>t,season, pos', 'self, no const.','self time','self season','self p',...
%     'self time season','self time pos','self season pos','self all const','self >t','self >t,season,pos','null model'};



figure(1); clf; boxplot([bar1,bar2],'plotstyle','compact','labels',alllabels,'colors',[.5,.5,.5]);
 ylim([0,10]); ylabel('Normalized MSE'); set(gcf,'color','w');

 
 Tab2 = [bar1,bar2];
 q1 = zeros(1,21); 
 q3 = zeros(1,21); 
 
 for i=1:21
     Tab2(:,i) = sort(Tab2(:,i));
     q1(i) = Tab2(round(13/4),i);
     q3(i) = Tab2(round(3*13/4),i);
 end
 
 p_self = zeros(1,10);
 for i=1:10
    p_self(i) = ranksum(Tab2(:,i),Tab2(:,i+10));
 end
    
 %med = nanmedian(Tab2)
 
 

 ranksum(bar1(:,1),m_err)
 

 for k=1:13
    Ps(k) = ranksum(ErrEn(k,:,1),ErrEn(k,:,8)) ;
 end

 
% CE_Data =[];
% for j=1:Fs
%     CE_Data = [CE_Data; ErrEn(:,:,j)];
% end
% folder = '/Users/alistair/Documents/Berkeley/Getz Lab';
%  dlmwrite([folder,'/CrossET_data2.txt'],CE_Data);
