
% Alistair Boettiger                                Date Begun: 07/09/09
% Getz Lab 

clear all;
K=13;



  % Chose NDVI torus parameters 
    ri = 1;
    ro = 5; % 6km optimal NDVI perception chosen from NDVI studies
    segs = 9; % number of segments in which to divide NDVI values
    hrs = 24; % number of hours used for position density calc.
    hr = 1;  % reduce sampling frequency
    his = hrs/hr; 
    
       dpts = 5+segs+3; % total number of data points per elephant to export

   load E_data; % data on 12 elephants from 01/13/00 to 06/25/07, sampled hourly  
   load NDVIs; % NDVI data with hourly index reference and lat and long references only sampled from Jan 00 through Dec 06  
   load e_stats4 xcm ycm ra rb o;  % import results from COM tracking
        
    T2 = length(xcm) - 2*his; % length of inputs and outputs 
        
    % find time at which each elephant starts recording and stops recording
    [jnk t1] = max(xcm>0); % sets all nonzero elements to 1, max returns first of equivelant maxes 
    [jnk tend] = max(flipud(xcm)>0);
    tend = length(xcm)-tend+1;

        % convert inputs with missing data to NaN flags
        %     (this avoids upsetting min max rescaling, difference calcs, etc)
        Xcm = xcm;  Xcm(xcm==0)=NaN;
        Ycm = ycm;  Ycm(ycm==0)=NaN;
        Ra = ra;  Ra(ra==0)=NaN;
        Rb = ra;  Rb(rb==0)=NaN;
        O = o;  O(o==0)=NaN;
        
         Edat = [length(Xcm),K*dpts];


for E = 1:K     % loop through elephant on which to center analysis  

    % ~~~~~~~~~~~~~Import Elephant Tracking data~~~~~~~~~~~~~~ %

    % seperate out lat and long data for the first K elephants
   %  Elats = data(:,1:2:2*K); Elongs = data(:,2:2:2*K);

    % Compute COMs and bounding ellipses
    %[xcm, ycm, ra, rb, o] = bnd_ellipse_multi(Elongs,Elats,K,his);
    % % save e_stats3 xcm ycm ra rb o % save results from COM tracking
  
         Ti = t1(E); % restrict time to interval for choice elephant
         Te = tend(E); %


   
  % ~~~~~~~~~~~~~~~~Import static data~~~~~~~~~~~~~~~~~~~~~%
    load dist_quant; % static envi. measures
    % locate elephant motions on static-data raster maps
    yis = find(Slat> min(Ycm(Ti:Te,E)) & Slat< max(Ycm(Ti:Te,E)) );
    xis = find(Slong> min(Xcm(Ti:Te,E)) & Slong< max(Xcm(Ti:Te,E)) );
    grid_long = Slong(xis); % even grid points in degrees
    grid_lat = Slat(yis); 
    D2W = DtoWater2(yis(1):yis(end),xis(1):xis(end));
    D2P = DtoPark2(yis(1):yis(end),xis(1):xis(end));
    D2R = DtoRoad2(yis(1):yis(end),xis(1):xis(end));
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~%    
    

    T = Te-Ti; 
  
    % initialize data arrays
    scor = zeros(T,1); 
    sec_var=zeros(T,1); 
    mean_ndvi = zeros(T,segs) ;
     d2r = zeros(T,1); d2w=d2r; d2p=d2r;       
                  
    for j=1:T+1;
        t=Ti+j-1;
      % compute NDVI mean sector values,
         [jnk xc] = min(abs(long' - Xcm(t,E) )); % find closest grid point
         [jnk yc] = min(abs(lat' - Ycm(t,E) )); % j is current time
         [jnk xf] = min(abs(long' - Xcm(t+his) )); % j+his first nonoverlapping future time
         [jnk yf] = min(abs(lat' - Ycm(t+his) )); 
         i = Nind(t+his-1);     
        [mean_ndvi(j,:), scor(j), sec_var(j)] = NDVI_torus(NDVI(:,:,i),segs,xc,yc,ri,ro,xf,yf);
    %   % Static data analysis 
         [xer xposi] = min( abs( grid_long - Xcm(t,E) ) ); % find closest grid point to each K elephant points 
         [yer yposi] = min( abs( grid_lat - Ycm(t,E)  ) );
        d2r(j) = D2R(yposi,xposi);  % read the value of the Envi var at the nearest grid point to the elephant position 
        d2w(j) = D2W(yposi,xposi); % note lat and long need to be paired in time, so we only want the diag entries
        d2p(j) = D2P(yposi,xposi);
    %   j/T % progress ticker
    end
    
    
       load ave_ndvi;  time = ave_ndvi(Ti:Te); 
       seg_area = pi*ro^2/(segs-1)-pi*ri^2; 
       Eland = [mean_ndvi,d2r,d2w,d2p]; 
       sEdat= [Xcm(Ti:Te,E),Ycm(Ti:Te,E),Ra(Ti:Te,E),Rb(Ti:Te,E),O(Ti:Te,E),mean_ndvi,d2r,d2w,d2p];
    
  Edat(Ti:Te,dpts*(E-1)+1:dpts*E) = sEdat;

end
%      filename = ['/Users/alistair/Documents/Berkeley/Getz Lab/','Edata3_raw.txt'];
% csvwrite(filename,Edat);

Edat2 = Edat;
Edat2(isnan(Edat)) = 0; 
     filename = ['/Users/alistair/Documents/Berkeley/Getz Lab/','Edata3_raw.txt'];
csvwrite(filename,Edat2);

    
    
    
    
    
  
