%%                     Import NDVI data
% Alistair Boettiger                                   Date Begun: 01/28/08
% Getz Lab                                       Functional Since: 02/15/08
% Functionally Complete                             Last Modified: 02/21/08

clear all;
% Import NDVI data
file = 'C:\Documents and Settings\Alistair\My Documents\My Office Documents\Berkeley\Getz Lab\Elephant\ASCII_NDVI\';
%file = 'E:\My Office Documents\Berkeley\Getz Lab\Elephant\ASCII_NDVI\'

minlong = 37; maxlong = 39;
minlat = 0; maxlat = 1;

astp = (4.7+4.7)/1053; ostp = (41.9-33.9)/898;

ny = length(minlat:astp:maxlat)-1; % not sure if -1 is general or hack
nx = length(minlong:ostp:maxlong)-1;

NDVI = uint8(zeros(ny,nx,250)); mon{1} = '01'; k=1; ndate ={};
% clear sm yr mon mo fn fp D; 
for i = 1:300
    % auto-construct file name
        sm{i} = num2str(1+mod(i-1,3));     % sample number
        yr{i} = num2str( 2000 + floor(i/(3*12))); % year
        mo(i) = 1+mod(floor(i/3),12); if mo(i)<10; mon{i+1} = ['0',num2str(mo(i))];
        else mon{i+1} = num2str(mo(i)); end % month
        fn{i} = [yr{i},mon{i},sm{i},'.txt']; % filename
        fp{i} = [file,fn{i}]; % filepath
        ndate{i} = [mon{i+1}, '/', num2str(9*(1+mod(str2num(sm{i}),3))), '/', yr{i}];
         try
        D = dlmread(fp{i}); % import
%         [as os] = size(D);
%                     % as = 1053; os = 898;
        lats = linspace(-4.7,4.7,1053);
        longs = linspace(33.9,41.9,898);
        Hx = find((longs >= minlong & longs <= maxlong));
        Hy = find((lats >= minlat & lats <= maxlat));
        NDVI(:,:,i) = uint8(D(Hy,Hx));
        lat = lats(Hy);
        long = longs(Hx);
%          
%          
     figure(1); clf; 
     pcolor(longs(Hx), lats(Hy), flipud(double(NDVI(:,:,i)))); shading flat;
     title(fn{i});  pause(.1);    
    
        catch
            k = k+1;
            miss{k} = fn{i};
        end
        
end

% Set Geographic hills to cloud values (hills and clouds are both nulls)
load Slopes
[Xs Ys Ts] = size(NDVI);
for i=1:Ts
    Nt = flipud(NDVI(:,:,i));  % flip really?
    Nt((Slopes)>sl_T) = 255;
    NDVI(:,:,i) = Nt;
figure(5); clf; pcolor(Clong, Clat, double(NDVI(:,:,i))); shading flat;
pause(.01);
end




%save NDVI NDVI lat long ndate;


% load NDVI;
%   load J; ELat = J{1}; ELong = J{2}; Date = J{3};
% 
% 
% % sparser data arrays, sample every 'hr' hours
% hr = 8;  N=4; S = 40;
% ELats = ELat(1:hr:end)'; ELongs = ELong(1:hr:end)'; 
% nu = zeros(1,N); nul = nu; nur =nu; nl=nu; nr=nu; ndr=nu; ndl=nu; nd = nu; 
% 
% for i=1:N
%      [xer xpos] = min(abs(long' - ELongs(i))); % find closest grid point to each K elephant points 
%      [yer ypos] = min(abs(lat' - ELats(i)));
%      
%      nul(i) = mean(diag(NDVI(ypos:ypos+S,xpos-S:xpos,i)));
%      nu(i) = mean((NDVI(ypos:ypos+S,xpos:xpos,i)));
%      nur(i) = mean(diag((NDVI(ypos:ypos+S,xpos:xpos+S,i))));
%      nl(i) =  mean((NDVI(ypos:ypos,xpos-S:xpos,i)));
%      nr(i) =  mean((NDVI(ypos:ypos,xpos:xpos+S,i)));
%      ndl(i) = mean(diag((NDVI(ypos-S:ypos,xpos-S:xpos,i))));
%      ndr(i) = mean(diag((NDVI(ypos-S:ypos,xpos:xpos+S,i))));
%      nd(i) = mean(NDVI(ypos-S:ypos,xpos:xpos,i));
% end
