
% Import Elephant Tracking Data
clear all; 
% file = 'E:\Elephant\ElePositions\14 f52 Stratus 13 Jan 00 to 2 Aug 00.txt';
% lins = 10E5;
% [Longitude, Latitude, Date, Time, DOP, Fix, Status, Temp, Act, Convergence, Month] =  textread(file, '%f %f %s %s %s %s %s %s %s %s %s', lins, 'headerlines', 1);
% 
% 
% 
% % import shape data
% file = 'E:\My Office Documents\Berkeley\Getz Lab\Elephant\Shape';
% fn = 'Rivers_LandSat.shp'; 
% % fn = 'Bnd_polyline_Project.shp';
% [s, a] = shaperead([file,'\',fn]) ;
% 
% 
% % Import Elevation Data
% %fn = 'E:\My Office Documents\Berkeley\Getz Lab\Elephant\srtm_44_12\Z_44_12';
%fn = 'C:\Documents and Settings\Alistair\My Documents\My Office Documents\Berkeley\Getz Lab\Elephant\new_Elevation\Z_44_12';
% A = geotiffread(fn);
fn = '/Users/alistair/Documents/Berkeley/Getz Lab/Elevation.tiff';
I = double(imread(fn));
%35 E - 40E, %0N-5N.  1250 x 1250 per degree^2.  
minlong = 37; maxlong = 39;
minlat = 0; maxlat = 1;
%I = double(flipud(A(6000-(maxlat-minlat)*1250+1:6000, (minlong-35)*1250+1:(maxlong-35)*1250  )));

Elong = linspace(minlong,maxlong,(maxlong-minlong)*1250);
Elat = linspace(minlat,maxlat,(maxlat-minlat)*1250); 

figure(1); clf; pcolor(Elong,Elat,I); shading flat;
[Ix,Iy] = gradient(I);
[Long,Lat] = meshgrid(Elong,Elat); 
Grad = sqrt(Ix.^2 + Iy.^2);
figure(3); clf; pcolor(Elong,Elat,Grad); shading flat;
thresh = 25;
Hill = Grad;  Hill(Grad>thresh) = 1; Hill(Grad<=thresh)=0;
% Hill(Grad>2*thresh) = 2;  Hill(Grad>3*thresh) = 3;
% Hill(Grad>4*thresh) = 4; Hill(Grad>5*thresh) = 5;
figure(4), clf, pcolor(Elong, Elat, Hill); shading flat;

% drop resolution
imax = max(max(I));  imin = min(min(I));
Is = uint8( (I-imin)/(imax-imin) *255);  %figure(2); clf; imshow(Is);
folder = 'C:\Documents and Settings\Alistair\My Documents\My Office Documents\Berkeley\Getz Lab\';
imwrite(Hill,[folder ,'slopes.tiff'],'tiff');
I2 = imread([folder ,'grad.png']);
Clat = linspace(0,1,112);
Clong = linspace(37,39,224);
figure(1); clf; pcolor(Clong, Clat, double(I2)); shading flat;
figure(2); clf; imshow(I2);

Slopes = double(I2(:,1:end-1)); Slope = Slopes; sl_t = 70;
Slope(Slopes>sl_t) = 1; Slope(Slopes<=sl_t) = 0;
figure(2); clf; pcolor(double(Slope)); shading flat;
clear NDVI; load NDVI;
for i=1:251
    Nt = flipud(NDVI(:,:,i));
    Nt((Slopes)>70) = 255;
    NDVI(:,:,i) = Nt;
figure(5); clf; pcolor(Clong, Clat, double(NDVI(:,:,i))); shading flat;
pause(.01);
end

% save Slopes Slopes sl_t

imin = 200; imax = 600;
figure(2); clf; contour(Long(imin:imax,imin:imax),Lat(imin:imax,imin:imax),I(imin:imax,imin:imax));
hold on; quiver(Long(imin:imax,imin:imax), Lat(imin:imax,imin:imax), Ix(imin:imax,imin:imax), Iy(imin:imax,imin:imax));




% Import NDVI data
file = 'C:\Documents and Settings\Alistair\My Documents\My Office Documents\Berkeley\Getz Lab\Elephant\ASCII_NDVI\';

for i = 1:250
    % auto-construct file name
        sm = num2str(mod(i,3));     % sample number
        yr = num2str( 2000 + floor(i/(3*12))); % year
        mo = 1+floor(i/3); if mo<10; mon = ['0',num2str(mo)]; end % month
        fn{i} = [yr,mon,sm,'.txt']; % filename
        fp{i} = [file,fn{i}]; % filepath
        D = dlmread(fp{i}); % import
        [as os] = size(D);
        lats = linspace(-4.7,4.7,as);
        longs = linspace(33.9,41.9,os);
        figure(1); clf; pcolor(longs,lats, flipud(D)); shading flat;
        % figure(1); clf; imshow(uint8(D)); shading flat;
        
end

